/***************************************************************************
                             transactioneditorcontainer.h
                             ----------
    begin                : Wed Jun 07 2006
    copyright            : (C) 2006 by Thomas Baumgart
    email                : Thomas Baumgart <ipwizard@users.sourceforge.net>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TRANSACTIONEDITORCONTAINER_H
#define TRANSACTIONEDITORCONTAINER_H

// ----------------------------------------------------------------------------
// TQt Includes

#include <tqmap.h>
#include <tqstring.h>
#include <tqtable.h>
class TQWidget;

// ----------------------------------------------------------------------------
// TDE Includes


// ----------------------------------------------------------------------------
// Project Includes

namespace KMyMoneyRegister { class Transaction; };

typedef enum {
  ProtectNone = 0,
  ProtectTransfer,
  ProtectNonTransfer,
  ProtectAll
} ProtectedAction;

class TransactionEditorContainer : public TQTable
{
public:
  TransactionEditorContainer(TQWidget* parent, const char* name) : TQTable(parent, name) {}

  virtual void arrangeEditWidgets(TQMap<TQString, TQWidget*>& editWidgets, KMyMoneyRegister::Transaction* t) = 0;
  virtual void removeEditWidgets(TQMap<TQString, TQWidget*>& editWidgets) = 0;
  virtual void tabOrder(TQWidgetList& tabOrderWidgets, KMyMoneyRegister::Transaction* t) const = 0;
  // FIXME remove tabbar
  // virtual int action(TQMap<TQString, TQWidget*>& editWidgets) const = 0;
  // virtual void setProtectedAction(TQMap<TQString, TQWidget*>& editWidgets, ProtectedAction action) = 0;
};

#endif
